Needle Gauge in JavaScript

Using ApexCharts with JavaScript

This Needle Gauge example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [68],
  chart: {
    height: 360,
    type: 'gauge',
  },
  plotOptions: {
    radialBar: {
      shape: 'needle',
      startAngle: -135,
      endAngle: 135,
      min: 0,
      max: 100,
      bands: [
        { from: 0, to: 30, color: '#FF4560' },
        { from: 30, to: 70, color: '#FEB019' },
        { from: 70, to: 100, color: '#00E396' },
      ],
      bandsStyle: {
        strokeWidth: '50%',
        gap: 1,
      },
      ticks: {
        show: true,
        major: {
          count: 11,
          length: 8,
          width: 2,
          color: '#334155',
          placement: 'outside',
        },
        minor: {
          count: 1,
          length: 4,
          width: 1,
          color: '#94A3B8',
          placement: 'outside',
        },
        labels: {
          show: true,
          offset: 6,
          fontSize: '11px',
          color: '#334155',
        },
      },
      needle: {
        color: '#0F172A',
        length: '60%',
        baseWidth: 6,
        tipWidth: 1,
      },
      hollow: {
        margin: 0,
        size: '70%',
      },
      dataLabels: {
        name: { show: false },
        value: {
          offsetY: 32,
          fontSize: '28px',
          fontWeight: 700,
          formatter: function (val) {
            return val
          },
        },
      },
    },
  },
  labels: ['Speed'],
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Needle Gauge in Angular

Using ApexCharts with Angular

This Needle Gauge example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [68],
          chart: {
            height: 360,
            type: 'gauge',
          },
          plotOptions: {
            radialBar: {
              shape: 'needle',
              startAngle: -135,
              endAngle: 135,
              min: 0,
              max: 100,
              bands: [
                { from: 0, to: 30, color: '#FF4560' },
                { from: 30, to: 70, color: '#FEB019' },
                { from: 70, to: 100, color: '#00E396' },
              ],
              bandsStyle: {
                strokeWidth: '50%',
                gap: 1,
              },
              ticks: {
                show: true,
                major: {
                  count: 11,
                  length: 8,
                  width: 2,
                  color: '#334155',
                  placement: 'outside',
                },
                minor: {
                  count: 1,
                  length: 4,
                  width: 1,
                  color: '#94A3B8',
                  placement: 'outside',
                },
                labels: {
                  show: true,
                  offset: 6,
                  fontSize: '11px',
                  color: '#334155',
                },
              },
              needle: {
                color: '#0F172A',
                length: '60%',
                baseWidth: 6,
                tipWidth: 1,
              },
              hollow: {
                margin: 0,
                size: '70%',
              },
              dataLabels: {
                name: { show: false },
                value: {
                  offsetY: 32,
                  fontSize: '28px',
                  fontWeight: 700,
                  formatter: (val) => {
                    return val
                  },
                },
              },
            },
          },
          labels: ['Speed'],
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Needle Gauge in React

Using ApexCharts with React

This Needle Gauge example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [68],
    options: {
      chart: {
        height: 360,
        type: 'gauge',
      },
      plotOptions: {
        radialBar: {
          shape: 'needle',
          startAngle: -135,
          endAngle: 135,
          min: 0,
          max: 100,
          bands: [
            { from: 0, to: 30, color: '#FF4560' },
            { from: 30, to: 70, color: '#FEB019' },
            { from: 70, to: 100, color: '#00E396' },
          ],
          bandsStyle: {
            strokeWidth: '50%',
            gap: 1,
          },
          ticks: {
            show: true,
            major: {
              count: 11,
              length: 8,
              width: 2,
              color: '#334155',
              placement: 'outside',
            },
            minor: {
              count: 1,
              length: 4,
              width: 1,
              color: '#94A3B8',
              placement: 'outside',
            },
            labels: {
              show: true,
              offset: 6,
              fontSize: '11px',
              color: '#334155',
            },
          },
          needle: {
            color: '#0F172A',
            length: '60%',
            baseWidth: 6,
            tipWidth: 1,
          },
          hollow: {
            margin: 0,
            size: '70%',
          },
          dataLabels: {
            name: { show: false },
            value: {
              offsetY: 32,
              fontSize: '28px',
              fontWeight: 700,
              formatter: function (val) {
                return val
              },
            },
          },
        },
      },
      labels: ['Speed'],
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="gauge"
          height={360}
        />
      </div>
    </div>
  )
}

export default ApexChart

Needle Gauge in Vue

Using ApexCharts with Vue

This Needle Gauge example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="gauge"
        height="360"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [68],
      chartOptions: {
        chart: {
          height: 360,
          type: 'gauge',
        },
        plotOptions: {
          radialBar: {
            shape: 'needle',
            startAngle: -135,
            endAngle: 135,
            min: 0,
            max: 100,
            bands: [
              { from: 0, to: 30, color: '#FF4560' },
              { from: 30, to: 70, color: '#FEB019' },
              { from: 70, to: 100, color: '#00E396' },
            ],
            bandsStyle: {
              strokeWidth: '50%',
              gap: 1,
            },
            ticks: {
              show: true,
              major: {
                count: 11,
                length: 8,
                width: 2,
                color: '#334155',
                placement: 'outside',
              },
              minor: {
                count: 1,
                length: 4,
                width: 1,
                color: '#94A3B8',
                placement: 'outside',
              },
              labels: {
                show: true,
                offset: 6,
                fontSize: '11px',
                color: '#334155',
              },
            },
            needle: {
              color: '#0F172A',
              length: '60%',
              baseWidth: 6,
              tipWidth: 1,
            },
            hollow: {
              margin: 0,
              size: '70%',
            },
            dataLabels: {
              name: { show: false },
              value: {
                offsetY: 32,
                fontSize: '28px',
                fontWeight: 700,
                formatter: function (val) {
                  return val
                },
              },
            },
          },
        },
        labels: ['Speed'],
      },
    }
  },
}
</script>

<style>
#chart {
  padding: 0;
  max-width: 420px;
  margin: 35px auto;
}
</style>